VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsKredit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements SmartTagLib.ISmartDocument

'diese Schemata muessen vorhanden sein, damit das SmartDoc auf Klicks in zugeordneten Zellen reagiert
Private Const cstrInputNamespace = "www.dr-e-pfeifer.de/xlRezepteInput"
Private Const cstrOutputNamespace = "www.dr-e-pfeifer.de/xlRezepteOutput"

'das ermoeglicht den Start ohne individuelle Schemata
Private Const cstrDefaultTypeName = "http://schemas.microsoft.com/office/smartdocuments/2003#default"

'diese Name sind die aus dem zugeordneten Input-Schema
Private Const cstrTypeNameInputKreditsumme = cstrInputNamespace & "#Kreditsumme"
Private Const cstrTypeNameInputZinssatz = cstrInputNamespace & "#Zinssatz"
Private Const cstrTypeNameInputTilgungssatz = cstrInputNamespace & "#Tilgungssatz"

'diese Name sind die aus dem zugeordneten Output-Schema
Private Const cstrTypeNameOutputMonatsbelastung = cstrOutputNamespace & "#Monatsbelastung"
Private Const cstrTypeNameOutputLaufzeit = cstrOutputNamespace & "#Laufzeit"

Private Const cintNumberOfTypeNames = 6

Private strSolutionDir As String

Private Sub ISmartDocument_OnPaneUpdateComplete(ByVal Target As Object)

End Sub

Private Sub ISmartDocument_PopulateOther(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As SmartTagLib.ISmartDocProperties)

End Sub

Private Sub ISmartDocument_SmartDocInitialize(ByVal ApplicationName As String, ByVal Document As Object, ByVal SolutionPath As String, ByVal SolutionRegKeyRoot As String)
    'alle Dateien befinden sich nach dem Download im Solution-Ordner
    strSolutionDir = SolutionPath & "\"
End Sub

Private Property Get ISmartDocument_SmartDocXMLTypeCount() As Long
    'Anzahl der Dokumentteile (Typen)
    ISmartDocument_SmartDocXMLTypeCount = cintNumberOfTypeNames
End Property

Private Property Get ISmartDocument_SmartDocXMLTypeName(ByVal SmartDocID As Long) As String
    'Zuordnung von Namen fuer die Liste der Typen
    Select Case SmartDocID
        Case 1
            ISmartDocument_SmartDocXMLTypeName = cstrDefaultTypeName
        Case 2
            ISmartDocument_SmartDocXMLTypeName = cstrTypeNameInputKreditsumme
        Case 3
            ISmartDocument_SmartDocXMLTypeName = cstrTypeNameInputZinssatz
        Case 4
            ISmartDocument_SmartDocXMLTypeName = cstrTypeNameInputTilgungssatz
        Case 5
            ISmartDocument_SmartDocXMLTypeName = cstrTypeNameOutputMonatsbelastung
        Case 6
            ISmartDocument_SmartDocXMLTypeName = cstrTypeNameOutputLaufzeit
    End Select
End Property

Private Property Get ISmartDocument_SmartDocXMLTypeCaption(ByVal SmartDocID As Long, ByVal LocaleID As Long) As String
    'Ueberschriften der Dokumentteile (Typen)
    Select Case SmartDocID
        Case 1
            ISmartDocument_SmartDocXMLTypeCaption = "Kreditrechner"
        Case 2
            ISmartDocument_SmartDocXMLTypeCaption = "Eingabe der Kreditsumme"
        Case 3
            ISmartDocument_SmartDocXMLTypeCaption = "Variation des Zinssatzes"
        Case 4
            ISmartDocument_SmartDocXMLTypeCaption = "Variation des Tilgungssatzes"
        Case 5
            ISmartDocument_SmartDocXMLTypeCaption = "Verlag"
        Case 6
            ISmartDocument_SmartDocXMLTypeCaption = "Verlag"
    End Select
End Property

Private Property Get ISmartDocument_ControlCount(ByVal SmartDocXMLTypeName As String) As Long
    'Festlegung der Anzahl der Steuerelemente pro Typ ueber dessen Namen
    Select Case SmartDocXMLTypeName
        Case cstrDefaultTypeName
           ISmartDocument_ControlCount = 4
        Case cstrTypeNameInputKreditsumme
           ISmartDocument_ControlCount = 2
        Case cstrTypeNameInputZinssatz
           ISmartDocument_ControlCount = 2
        Case cstrTypeNameInputTilgungssatz
           ISmartDocument_ControlCount = 2
        Case cstrTypeNameOutputMonatsbelastung
           ISmartDocument_ControlCount = 1
        Case cstrTypeNameOutputLaufzeit
           ISmartDocument_ControlCount = 1
        Case Else
           ISmartDocument_ControlCount = 0
    End Select
End Property

Private Property Get ISmartDocument_ControlID(ByVal SmartDocXMLTypeName As String, ByVal ControlIndex As Long) As Long
    'Festlegen von ID aus dem Index
    Select Case SmartDocXMLTypeName
        Case cstrDefaultTypeName
            ISmartDocument_ControlID = ControlIndex
        Case cstrTypeNameInputKreditsumme
            ISmartDocument_ControlID = ControlIndex + 100
        Case cstrTypeNameInputZinssatz
            ISmartDocument_ControlID = ControlIndex + 200
        Case cstrTypeNameInputTilgungssatz
            ISmartDocument_ControlID = ControlIndex + 300
        Case cstrTypeNameOutputMonatsbelastung
            ISmartDocument_ControlID = ControlIndex + 400
        Case cstrTypeNameOutputLaufzeit
            ISmartDocument_ControlID = ControlIndex + 500
        Case Else
            ISmartDocument_ControlID = 0
    End Select
End Property

Private Property Get ISmartDocument_ControlTypeFromID(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long) As C_TYPE
    'welche Art Steuerelement steckt hinter der ID
    Select Case ControlID
        Case 1, 2, 3
            ISmartDocument_ControlTypeFromID = C_TYPE_LINK
        Case 4
            ISmartDocument_ControlTypeFromID = C_TYPE_HELPURL
        Case 101
            ISmartDocument_ControlTypeFromID = C_TYPE_HELP
        Case 102
            ISmartDocument_ControlTypeFromID = C_TYPE_TEXTBOX
        Case 103
            ISmartDocument_ControlTypeFromID = C_TYPE_LINK
        Case 201, 202
            ISmartDocument_ControlTypeFromID = C_TYPE_LINK
        Case 301
            ISmartDocument_ControlTypeFromID = C_TYPE_RADIOGROUP
        Case 302
            ISmartDocument_ControlTypeFromID = C_TYPE_RADIOGROUP
        Case 401
            ISmartDocument_ControlTypeFromID = C_TYPE_LINK
        Case 501
            ISmartDocument_ControlTypeFromID = C_TYPE_LINK
    End Select
End Property

Private Property Get ISmartDocument_ControlNameFromID(ByVal ControlID As Long) As String
    'friendly names fuer VBA-Projekt der Mappe
    ISmartDocument_ControlNameFromID = "xlRezepte" & ControlID
End Property

Private Property Get ISmartDocument_ControlCaptionFromID(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long, ByVal bstrText As String, ByVal bstrXML As String, ByVal Target As Object) As String
    'Bezeichner fuer die Steuerelemente
    Select Case ControlID
        Case 1
            ISmartDocument_ControlCaptionFromID = "Kundendaten holen"
        Case 2
            ISmartDocument_ControlCaptionFromID = "Daten lschen"
        Case 3
            ISmartDocument_ControlCaptionFromID = "Berechnungen exportieren"
        Case 4
            ISmartDocument_ControlCaptionFromID = "Hilfetext"
        Case 101
            ISmartDocument_ControlCaptionFromID = "Hilfe zur Kreditsumme"
        Case 102
            ISmartDocument_ControlCaptionFromID = "Kreditsumme ndern"
        Case 201
            ISmartDocument_ControlCaptionFromID = "gnstiger Zinssatz"
        Case 202
            ISmartDocument_ControlCaptionFromID = "ungntiger Zinssatz"
        Case 301
            ISmartDocument_ControlCaptionFromID = "Tilgungsgeschwindigkeit"
        Case 401
            ISmartDocument_ControlCaptionFromID = "HomePage des Verlags"
        Case 501
            ISmartDocument_ControlCaptionFromID = "HomePage des Verlags"
    End Select
End Property

Private Sub ISmartDocument_PopulateHelpContent(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As SmartTagLib.ISmartDocProperties, Content As String)
    'was passiert bei Help-Elementen
    Select Case ControlID
        Case 4
            Content = strSolutionDir & "help.htm"
            Props.Write "ExpandHelp", "False"
        Case 101
            Content = "<html><body>Kreditsumme, kann variiert werden</body></html>"
            Props.Write "ExpandHelp", "False"
    End Select
End Sub

Private Sub ISmartDocument_PopulateImage(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As SmartTagLib.ISmartDocProperties, ImageSrc As String)
    Select Case ControlID
    End Select
End Sub

Private Sub ISmartDocument_ImageClick(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal Target As Object, ByVal Text As String, ByVal Xml As String, ByVal LocaleID As Long, ByVal XCoordinate As Long, ByVal YCoordinate As Long)
    Select Case ControlID
    End Select
End Sub

Private Sub ISmartDocument_PopulateCheckbox(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As SmartTagLib.ISmartDocProperties, Checked As Boolean)
    Select Case ControlID
    End Select
End Sub

Private Sub ISmartDocument_OnCheckboxChange(ByVal ControlID As Long, ByVal Target As Object, ByVal Checked As Boolean)
    Select Case ControlID
    End Select
End Sub

Private Sub ISmartDocument_PopulateListOrComboContent(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As SmartTagLib.ISmartDocProperties, List() As String, Count As Long, InitialSelected As Long)
    Select Case ControlID
    End Select
End Sub


Private Sub ISmartDocument_OnListOrComboSelectChange(ByVal ControlID As Long, ByVal Target As Object, ByVal Selected As Long, ByVal Value As String)
    Select Case ControlID
    End Select
End Sub


Private Sub ISmartDocument_PopulateRadioGroup(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As SmartTagLib.ISmartDocProperties, List() As String, Count As Long, InitialSelected As Long)
    'Festlegen der Gruppe der Optionssch.
    Select Case ControlID
        Case 301
            Count = 3
            List(1) = "langsame Tilgung"
            List(2) = "normale Tilgung"
            List(3) = "schnelle Tilgung"
    End Select
End Sub

Private Sub ISmartDocument_OnRadioGroupSelectChange(ByVal ControlID As Long, ByVal Target As Object, ByVal Selected As Long, ByVal Value As String)
    'was passiert beim Klick auf Opt.
    Select Case ControlID
            Case 301
            Select Case Selected
                Case 1
                    Target.Value = 0.01
                Case 2
                    Target.Value = 0.02
                Case 3
                    Target.Value = 0.04
            End Select
    End Select
End Sub

Private Sub ISmartDocument_OnRadioSelectChange(ByVal ControlID As Long, ByVal Target As Object, ByVal Selected As Long, ByVal Value As String)
    Select Case ControlID
    End Select
End Sub

Private Sub ISmartDocument_PopulateTextboxContent(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As SmartTagLib.ISmartDocProperties, Value As String)
    Select Case ControlID
    End Select
End Sub

Private Sub ISmartDocument_OnTextboxContentChange(ByVal ControlID As Long, ByVal Target As Object, ByVal Value As String)
    'Textbox auswerten
    Select Case ControlID
        Case 102
            Target.Value = CDbl(Value)
    End Select
End Sub

Private Sub ISmartDocument_PopulateActiveXProps(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As SmartTagLib.ISmartDocProperties, ByVal ActiveXPropBag As SmartTagLib.ISmartDocProperties)
    Select Case ControlID
    End Select
End Sub

Private Sub ISmartDocument_PopulateDocumentFragment(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal LocaleID As Long, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As SmartTagLib.ISmartDocProperties, DocumentFragment As String)
    Select Case ControlID
    End Select
End Sub

Private Sub ISmartDocument_InvokeControl(ByVal ControlID As Long, ByVal ApplicationName As String, ByVal Target As Object, ByVal Text As String, ByVal Xml As String, ByVal LocaleID As Long)
    'das ist fuer die Links
    Select Case ControlID
        Case 1
            Target.XmlMaps("inputData_Zuordnung").Import strSolutionDir & "Kundendaten.xml", True
            Target.Parent.range("C4").Select
        Case 2
            Target.XmlMaps("inputData_Zuordnung").Import strSolutionDir & "reset.xml", True
        Case 3
            Target.XmlMaps("outputData_Zuordnung").Export strSolutionDir & "output.xml", True
            MsgBox "Export durchgefhrt."
        Case 201
            Target.Value = 0.05
        Case 202
            Target.Value = 0.09
        Case 401, 501
            Dim ie As Object
            Set ie = CreateObject("Internetexplorer.Application")
            ie.navigate2 "http://www.edv-buchversand.de/mspress/default.asp"
            ie.Visible = True
        End Select
End Sub



