Imports Office = Microsoft.Office.Core
Imports Extensibility
Imports System.Runtime.InteropServices
Imports Excel = Microsoft.Office.Interop.Excel

#Region " Read me for Add-in installation and setup information. "
' When run, the Add-in wizard prepared the registry for the Add-in.
' At a later time, if the Add-in becomes unavailable for reasons such as:
'   1) You moved this project to a computer other than which is was originally created on.
'   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
'   3) Registry corruption.
' you will need to re-register the Add-in by building the K14_01Setup project 
' by right clicking the project in the Solution Explorer, then choosing install.
#End Region

<GuidAttribute("5F91E7B9-1FC0-44EE-835C-1CAE4E8BD0C7"), ProgIdAttribute("K14_01.AddIn")> _
Public Class clsAddIn

    Implements Extensibility.IDTExtensibility2
    Dim WithEvents applicationObject As Excel.Application
    Dim cb As Office.CommandBar
    Dim WithEvents cbbNew As Office.CommandBarButton
    Dim WithEvents cbcAct As Office.CommandBarComboBox

    Public Sub OnBeginShutdown(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnBeginShutdown
    End Sub

    Public Sub OnAddInsUpdate(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnAddInsUpdate
    End Sub

    Public Sub OnStartupComplete(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnStartupComplete
    End Sub

    Public Sub OnDisconnection(ByVal RemoveMode As Extensibility.ext_DisconnectMode, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnDisconnection
        Try
            cb.Delete()
        Catch ex As Exception

        End Try
    End Sub

    Public Sub OnConnection(ByVal application As Object, ByVal connectMode As Extensibility.ext_ConnectMode, ByVal addInInst As Object, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnConnection
        applicationObject = application

        Try
            cb = applicationObject.CommandBars("K14_01")
        Catch ex As Exception
            cb = applicationObject.CommandBars.Add(Name:="K14_01", Position:=Office.MsoBarPosition.msoBarBottom, Temporary:=True)
        End Try
        While cb.Controls.Count > 0
            cb.Controls(1).Delete()
        End While

        cbbNew = cb.Controls.Add(Office.MsoControlType.msoControlButton, Temporary:=True)
        cbbNew.Style = Office.MsoButtonStyle.msoButtonIcon
        cbbNew.FaceId = 18
        cbcAct = cb.Controls.Add(Office.MsoControlType.msoControlDropdown, Temporary:=True)
        cb.Protection = Office.MsoBarProtection.msoBarNoCustomize
        cb.Visible = True
        FillComboBox()
    End Sub

    Sub FillComboBox()
        Dim wb As Excel.Workbook
        Dim bln As Boolean
        Dim i As Integer
        Dim strName As String
        Dim intActualIndex As Integer
        cbcAct.Clear()
        For Each wb In applicationObject.Workbooks
            Try
                bln = wb.CustomDocumentProperties("xlRezepte").value
            Catch ex As Exception
            Finally
                If bln Then
                    cbcAct.AddItem(wb.Name)
                    bln = False
                End If
            End Try
        Next
        strName = applicationObject.ActiveWorkbook.Name
        For i = 1 To cbcAct.ListCount
            If cbcAct.List(i) = strName Then
                intActualIndex = i
            End If
        Next
        cbcAct.ListIndex = intActualIndex
    End Sub

    Private Sub cbbNew_Click(ByVal Ctrl As Office.CommandBarButton, ByRef CancelDefault As Boolean) Handles cbbNew.Click
        Dim wb As Excel.Workbook = applicationObject.Workbooks.Add
        Dim wsh As Excel.Worksheet
        wb.CustomDocumentProperties.add("xlRezepte", False, Office.MsoDocProperties.msoPropertyTypeBoolean, True)
        wsh = wb.Worksheets(1)
        wsh.Range("A1").Value = Now
        wsh.UsedRange.Columns.AutoFit()
        FillComboBox()
    End Sub

    Private Sub applicationObject_NewWorkbook(ByVal Wb As Excel.Workbook) Handles applicationObject.NewWorkbook
        FillComboBox()
    End Sub

    Private Sub applicationObject_WorkbookDeactivate(ByVal Wb As Excel.Workbook) Handles applicationObject.WorkbookDeactivate
        FillComboBox()
    End Sub

    Private Sub applicationObject_WorkbookActivate(ByVal Wb As Excel.Workbook) Handles applicationObject.WorkbookActivate
        FillComboBox()
    End Sub

    Private Sub cbcAct_Change(ByVal Ctrl As Office.CommandBarComboBox) Handles cbcAct.Change
        Dim wb As Excel.Workbook = applicationObject.Workbooks(cbcAct.List(cbcAct.ListIndex))
        wb.Activate()
    End Sub

End Class
