Imports System.Windows.Forms
Imports Office = Microsoft.Office.Core
Imports Excel = Microsoft.Office.Interop.Excel
Imports MSForms = Microsoft.Vbe.Interop.Forms

' Office-Integrationsattribut. Gibt die Startklasse fr die Arbeitsmappe an. Nicht ndern.
<Assembly: System.ComponentModel.DescriptionAttribute("OfficeStartupClass, Version=1.0, Class=K14_02.OfficeCodeBehind")>

Public Class OfficeCodeBehind 

    Friend WithEvents ThisWorkbook As Excel.Workbook
    Friend WithEvents ThisApplication As Excel.Application
    Dim cb As Office.CommandBar
    Dim WithEvents cbb As Office.CommandBarButton
    Dim WithEvents cbc As Office.CommandBarComboBox
#Region "Generierter Initialisierungscode"

    ' Standardkonstruktor.
    Public Sub New()
    End Sub

    ' Erforderliche Prozedur. Nicht ndern.
    Public Sub _Startup(ByVal application As Object, ByVal workbook As Object)
        ThisApplication = CType(application, Excel.Application)
        ThisWorkbook = CType(workbook, Excel.Workbook)


    End Sub

    ' Erforderliche Prozedur. Nicht ndern.
    Public Sub _Shutdown()
        ThisApplication = Nothing
        ThisWorkbook = Nothing
    End Sub

    ' Gibt das Steuerelement mit dem angegebenen Namen auf der aktiven Arbeitsmappe von 'ThisWorkbook' zurck.
    Overloads Function FindControl(ByVal name As String) As Object
        Return FindControl(name, CType(ThisWorkbook.ActiveSheet, Excel.Worksheet))
    End Function

    ' Gibt das Steuerelement mit dem angegebenen Namen auf der angegebenen Arbeitsmappe zurck.
    Overloads Function FindControl(ByVal name As String, ByVal sheet As Excel.Worksheet) As Object
        Dim theObject As Excel.OLEObject
        Try
            theObject = CType(sheet.OLEObjects(name), Excel.OLEObject)
            Return theObject.Object
        Catch Ex As Exception
            ' Gibt 'Nothing' zurck, wenn das Steuerelement nicht gefunden wurde.
        End Try
        Return Nothing
    End Function
#End Region

    Private Sub ThisWorkbook_Open() Handles ThisWorkbook.Open
        Try
            cb = ThisApplication.CommandBars(Index:="K14_02")
        Catch ex As Exception
            cb = ThisApplication.CommandBars.Add(Name:="K14_02", temporary:=True)
        End Try
        cb.Visible = True
        cbb = cb.Controls.Add(Type:=Office.MsoControlType.msoControlButton)
        cbb.Style = Office.MsoButtonStyle.msoButtonCaption
        cbb.Caption = "Ordnen"
        cbc = cb.Controls.Add(Type:=Office.MsoControlType.msoControlComboBox)
        FillComboBox()
    End Sub

    Private Sub ThisWorkbook_BeforeClose(ByRef Cancel As Boolean) Handles ThisWorkbook.BeforeClose
        Try
            cb.Delete()
        Catch ex As Exception
        End Try
        Cancel = False
    End Sub

    Private Sub ThisApplication_WindowDeactivate(ByVal Wb As Excel.Workbook, ByVal Wn As Excel.Window) Handles ThisApplication.WindowDeactivate
        If Wb Is ThisWorkbook Then
            cb.Enabled = False
        End If
    End Sub

    Private Sub ThisApplication_WindowActivate(ByVal Wb As Excel.Workbook, ByVal Wn As Excel.Window) Handles ThisApplication.WindowActivate
        If Wb Is ThisWorkbook Then
            cb.Enabled = True
        Else
            cb.Enabled = False
        End If
    End Sub

    Private Sub ThisWorkbook_SheetActivate(ByVal Sh As Object) Handles ThisWorkbook.SheetActivate
        FillComboBox()
    End Sub

    Private Sub ThisWorkbook_SheetDeactivate(ByVal Sh As Object) Handles ThisWorkbook.SheetDeactivate
        FillComboBox()
    End Sub

    Private Sub ThisWorkbook_NewSheet(ByVal Sh As Object) Handles ThisWorkbook.NewSheet
        Dim wsh As Excel.Worksheet
        Try
            wsh = DirectCast(Sh, Excel.Worksheet)
        Catch ex As Exception
            MsgBox("Nur Arbeitsbltter erlaubt")
            Sh.delete()
        Finally
            FillComboBox()
        End Try

    End Sub

    Sub FillComboBox()
        Dim wsh As Excel.Worksheet
        cbc.Clear()
        For Each wsh In ThisWorkbook.Worksheets
            cbc.AddItem(wsh.Name)
        Next
        cbc.ListIndex = ThisWorkbook.ActiveSheet.index
    End Sub

    Private Sub cbc_Change(ByVal Ctrl As Office.CommandBarComboBox) Handles cbc.Change
        ThisWorkbook.Worksheets(cbc.ListIndex).activate()
    End Sub

    Private Sub cbb_Click(ByVal Ctrl As Office.CommandBarButton, ByRef CancelDefault As Boolean) Handles cbb.Click
        Dim intCount = ThisWorkbook.Worksheets.Count
        Dim ar As Array = Array.CreateInstance(GetType(String), ThisWorkbook.Worksheets.Count)
        Dim wsh As Excel.Worksheet
        Dim i As Integer
        For Each wsh In ThisWorkbook.Worksheets
            ar(wsh.Index - 1) = wsh.Name
        Next
        ar.Sort(ar)
        For i = 1 To intCount
            ThisWorkbook.Worksheets(ar(i)).move(after:=ThisWorkbook.Worksheets(intCount))
        Next
        ThisWorkbook.Worksheets(1).activate()
    End Sub

End Class
