Option Strict Off
Option Explicit On 

Imports Microsoft.Office.Interop.SmartTag
'Imports System.Runtime.InteropServices
'<ProgId("K14_04.clsK14_04"), GuidAttribute("1CBCDADD-7B4B-4cec-BE80-492488FB7C5F")> _
Public Class clsK14_04
    Implements ISmartDocument

    'diese Schemata muessen vorhanden sein, damit es beim Klicken ins Worksheet klappt
    Private Const cstrInputNamespace As String = "www.dr-e-pfeifer.net/xlRezepteNETinput"
    Private Const cstrProzenteNamespace As String = "www.dr-e-pfeifer.net/xlRezepteNETprozente"

    'das ermoeglicht den Start ohne individuelle Typenamen
    Private Const cstrDefaultTypeName As String = "http://schemas.microsoft.com/office/smartdocuments/2003#default"

    'die element names sind die aus dem zugeordneten Bestell-Schema
    Private Const cstrTypeNameArtNr As String = cstrInputNamespace & "#ArtNr"
    Private Const cstrTypeNameAnzahl As String = cstrInputNamespace & "#Anzahl"
    Private Const cstrTypeNameEinzelpreis As String = cstrInputNamespace & "#Einzelpreis"

    'die element names sind die aus dem zugeordneten Prozente-Schema
    Private Const cstrTypeNameMwst As String = cstrProzenteNamespace & "#Mwst"
    Private Const cstrTypeNameSkonto As String = cstrProzenteNamespace & "#Skonto"

    Private Const cintNumberOfTypeNames As Short = 6

    Private cstrSolutionDir As String

    Private Sub OnPaneUpdateComplete(ByVal Target As Object) Implements ISmartDocument.OnPaneUpdateComplete

    End Sub

    Private Sub PopulateOther(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As ISmartDocProperties) Implements ISmartDocument.PopulateOther

    End Sub

    Private Sub SmartDocInitialize(ByVal ApplicationName As String, ByVal Document As Object, ByVal SolutionPath As String, ByVal SolutionRegKeyRoot As String) Implements ISmartDocument.SmartDocInitialize
        'hier laesst sich alles fuer den Start einsetzen
        cstrSolutionDir = SolutionPath
    End Sub

    Private ReadOnly Property SmartDocXMLTypeCount() As Integer Implements ISmartDocument.SmartDocXMLTypeCount
        'Anzahl der Dokumentteile (Typen)
        Get
            Return cintNumberOfTypeNames
        End Get
    End Property
    Private ReadOnly Property SmartDocXMLTypeName(ByVal XMLTypeID As Integer) As String Implements ISmartDocument.SmartDocXMLTypeName
        'Zuordnung von Namen fuer die Liste der Typen
        Get
            Select Case XMLTypeID
                Case 1
                    Return cstrDefaultTypeName
                Case 2
                    Return cstrTypeNameArtNr
                Case 3
                    Return cstrTypeNameAnzahl
                Case 4
                    Return cstrTypeNameEinzelpreis
                Case 5
                    Return cstrTypeNameMwst
                Case 6
                    Return cstrTypeNameSkonto
            End Select
        End Get
    End Property

    Private ReadOnly Property SmartDocXMLTypeCaption(ByVal XMLTypeID As Integer, ByVal LocaleID As Integer) As String Implements ISmartDocument.SmartDocXMLTypeCaption
        'Ueberschriften der Dokumentteile (Typen)
        Get
            Select Case XMLTypeID
                Case 1
                    Return "Abrechnung"
                Case 2, 3, 4
                    Return "Bestelldetails"
                Case 5
                    Return "Mehrwertsteuersatz"
                Case 6
                    Return "Skonto"
            End Select
        End Get
    End Property

    Private ReadOnly Property ControlCount(ByVal XMLTypeName As String) As Integer Implements ISmartDocument.ControlCount
        'Festlegung der Anzahl der Steuerelemente pro Typ ueber dessen Namen
        Get
            Select Case XMLTypeName
                Case cstrDefaultTypeName
                    Return 1
                Case cstrTypeNameArtNr, cstrTypeNameAnzahl, cstrTypeNameEinzelpreis
                    Return 3
                Case cstrTypeNameMwst
                    Return 3
                Case cstrTypeNameSkonto
                    Return 1
                Case Else
                    Return 0
            End Select
        End Get
    End Property

    Private ReadOnly Property ControlID(ByVal XMLTypeName As String, ByVal ControlIndex As Integer) As Integer Implements ISmartDocument.ControlID
        'Festlegen von ID aus dem Index
        Get
            Select Case XMLTypeName
                Case cstrDefaultTypeName
                    Return ControlIndex
                Case cstrTypeNameArtNr
                    Return ControlIndex + 100
                Case cstrTypeNameAnzahl
                    Return ControlIndex + 200
                Case cstrTypeNameEinzelpreis
                    Return ControlIndex + 300
                Case cstrTypeNameMwst
                    Return ControlIndex + 400
                Case cstrTypeNameSkonto
                    Return ControlIndex + 500
            End Select
        End Get
    End Property
    Public ReadOnly Property ControlTypeFromID(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer) As C_TYPE Implements ISmartDocument.ControlTypeFromID
        'welcher Art Steuerelement steckt hinter der ID
        Get
            Select Case ControlID
                Case 1
                    Return C_TYPE.C_TYPE_HELPURL
                Case 101, 201, 301, 102, 202, 302
                    Return C_TYPE.C_TYPE_LINK
                Case 103, 203, 303
                    Return C_TYPE.C_TYPE_HELP
                Case 401, 402, 403
                    Return C_TYPE.C_TYPE_LINK
                Case 501
                    Return C_TYPE.C_TYPE_RADIOGROUP
            End Select
        End Get
    End Property

    Private ReadOnly Property ControlNameFromID(ByVal ControlID As Integer) As String Implements ISmartDocument.ControlNameFromID
        'friendly names fuer VBA
        Get
            Return "K14_04" & ControlID
        End Get
    End Property

    Private ReadOnly Property ControlCaptionFromID(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer, ByVal bstrText As String, ByVal bstrXML As String, ByVal Target As Object) As String Implements ISmartDocument.ControlCaptionFromID
        'Bezeichner fuer die Steuerelemente
        Get
            Select Case ControlID
                Case 1
                    Return "Hilfetext"
                Case 101, 201, 301
                    Return "Bestelldetails holen"
                Case 102, 202, 302
                    Return "Reset"
                Case 103, 203, 303
                    Return "Hilfe"
                Case 401
                    Return "normaler Mehrwertsteuersatz"
                Case 402
                    Return "ermigter Mehrwertsteuersatz"
                Case 403
                    Return "Mehrwertsteuer entfllt"
                Case 501
                    Return "Skonti auswhlen"
            End Select
        End Get
    End Property



    Private Sub PopulateHelpContent(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As ISmartDocProperties, ByRef Content As String) Implements ISmartDocument.PopulateHelpContent
        'was passiert bei Help-Elementen
        Select Case ControlID
            Case 1
                Content = cstrSolutionDir & "Hilfe.htm"
                Props.Write("ExpandHelp", "True")
            Case 103, 203, 303
                Content = "<html><body>Daten durch obige Links holen oder entfernen.</body></html>"
                Props.Write("ExpandHelp", "False")
        End Select
    End Sub

    Private Sub PopulateImage(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As ISmartDocProperties, ByRef ImageSrc As String) Implements ISmartDocument.PopulateImage
        Select Case ControlID
        End Select
    End Sub

    Private Sub ImageClick(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal Target As Object, ByVal Text As String, ByVal Xml As String, ByVal LocaleID As Integer, ByVal XCoordinate As Integer, ByVal YCoordinate As Integer) Implements ISmartDocument.ImageClick
        Select Case ControlID
        End Select
    End Sub

    Private Sub PopulateCheckbox(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As ISmartDocProperties, ByRef Checked As Boolean) Implements ISmartDocument.PopulateCheckbox
        Select Case ControlID
        End Select
    End Sub

    Private Sub OnCheckboxChange(ByVal ControlID As Integer, ByVal Target As Object, ByVal Checked As Boolean) Implements ISmartDocument.OnCheckboxChange
        Select Case ControlID
        End Select
    End Sub

    Private Sub PopulateListOrComboContent(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As ISmartDocProperties, ByRef List As System.Array, ByRef Count As Integer, ByRef InitialSelected As Integer) Implements ISmartDocument.PopulateListOrComboContent
        Select Case ControlID
        End Select
    End Sub


    Private Sub OnListOrComboSelectChange(ByVal ControlID As Integer, ByVal Target As Object, ByVal Selected As Integer, ByVal Value As String) Implements ISmartDocument.OnListOrComboSelectChange
        Select Case ControlID
        End Select
    End Sub


    Private Sub PopulateRadioGroup(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As ISmartDocProperties, ByRef List As System.Array, ByRef Count As Integer, ByRef InitialSelected As Integer) Implements ISmartDocument.PopulateRadioGroup
        'Festlegen der Gruppe der Optionssch.
        Select Case ControlID
            Case 501
                Count = 4
                List(1) = "3%"
                List(2) = "2%"
                List(3) = "1%"
                List(4) = "0%"
        End Select
    End Sub

    Private Sub OnRadioGroupSelectChange(ByVal ControlID As Integer, ByVal Target As Object, ByVal Selected As Integer, ByVal Value As String) Implements ISmartDocument.OnRadioGroupSelectChange
        'was passiert beim Klick auf Opt.
        Select Case ControlID
            Case 501
                Target.value = Value
        End Select
    End Sub

    Private Sub OnRadioSelectChange(ByVal ControlID As Integer, ByVal Target As Object, ByVal Selected As Integer, ByVal Value As String)
        Select Case ControlID
        End Select
    End Sub

    Private Sub PopulateTextboxContent(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As ISmartDocProperties, ByRef Value As String) Implements ISmartDocument.PopulateTextboxContent
        Select Case ControlID
        End Select
    End Sub

    Private Sub OnTextboxContentChange(ByVal ControlID As Integer, ByVal Target As Object, ByVal Value As String) Implements ISmartDocument.OnTextboxContentChange
        Select Case ControlID
        End Select
    End Sub

    Private Sub PopulateActiveXProps(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As ISmartDocProperties, ByVal ActiveXPropBag As ISmartDocProperties) Implements ISmartDocument.PopulateActiveXProps
        Select Case ControlID
        End Select
    End Sub

    Private Sub PopulateDocumentFragment(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal LocaleID As Integer, ByVal Text As String, ByVal Xml As String, ByVal Target As Object, ByVal Props As ISmartDocProperties, ByRef DocumentFragment As String) Implements ISmartDocument.PopulateDocumentFragment
        Select Case ControlID
        End Select
    End Sub

    Private Sub InvokeControl(ByVal ControlID As Integer, ByVal ApplicationName As String, ByVal Target As Object, ByVal Text As String, ByVal Xml As String, ByVal LocaleID As Integer) Implements ISmartDocument.InvokeControl
        'das ist fuer die Links
        Select Case ControlID
            Case 101, 201, 301
                Target.parent.parent.XmlMaps("Bestellungen_Zuordnung").Import(cstrSolutionDir & "bestellung.xml", True)
            Case 102, 202, 302
                Target.parent.parent.XmlMaps("Bestellungen_Zuordnung").Import(cstrSolutionDir & "reset.xml", True)
            Case 401
                Target.value = 0.16
            Case 402
                Target.value = 0.07
            Case 403
                Target.value = 0
        End Select
    End Sub


End Class